(** {1 Count letter frequency of a word}
    @author lillo
*)

(** {{:https://en.wikipedia.org/wiki/ASCII}ASCII} code of ['A'] letter. *)
let cbase = Char.code 'A'

(**
   Compute a {e frequency} letter table.
   @param string the word to analyse
   @return an array of frequency
*)
let char_freq string = 
  (* 1 *) let char_table = Array.make 26 0 in
  String.iter (fun c -> (* 6 *) let pos = (Char.code c) - cbase in
			char_table.(pos) <- char_table.(pos) + 1) string;
  char_table
  
(**
   {b Program main function.}
*)
let main () = 
  (* 1 *) let string = String.map Char.uppercase (read_line ()) in 
  let cfreq = char_freq string in
  Array.iteri (fun i f -> (* 26 *) Printf.printf "%c -> %d\n" (Char.chr (i + cbase)) f) cfreq

(**
   Program entry point.
*)
let _ = main ()
