(**
   A toy function to compress strings.
   @author lillo
*)

(**
   @param str the string to compress
   @return a compression version of str
*)
let compress str =
  let slen = String.length str in
  let buf = Buffer.create slen in
  let put_cchar char count =
    let s =
      if count > 1 then
	Printf.sprintf "%c{%d}" char count
      else
	Printf.sprintf "%c" char
    in
    Buffer.add_string buf s
  in
    
  let rec compr lastc count curr =
    if curr >= slen then
      put_cchar (str.[lastc]) count
    else
      if str.[curr] = str.[lastc] then
	compr lastc (count + 1) (curr + 1)
      else (
	put_cchar (str.[lastc]) count;
	compr curr 1 (curr + 1)
      )
  in
  (if str <> "" then
      compr 0 1 1);
  Buffer.contents buf
